function vexpower.markers.handler()
	--Clear Markers
	for i=1,#vexpower.markers.created do
		if vexpower.markers.created[i] ~= nil then
			vexpower.markers.created[i]:Hide()
		end
		vexpower.markers.created[i]=nil
	end
	vexpower.markers.created = {}
	
	--Set new markers
	local markers = vexpower_SV_markers[vexpower_SV_data["profile"]]
	for i,v in ipairs(markers) do
		if vexpower.markers.checkActivation(v["ressource"], v["spec"], v["class"], v["talent"]) then
			vexpower.markers.create(vexpower.powerBar.getWidth(v["position"])-0.5*vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["width"])
		end
	end
end

function vexpower.markers.checkTalents(talents)
	local returnvalue = true
	for row=1, 7 do
		for talent=1,3 do
			if select(4,GetTalentInfo(row, talent, GetActiveSpecGroup())) and not(talents[row][talent]) then
				returnvalue = false
			end
		end
	end
	return returnvalue
end

function vexpower.markers.checkActivation(ressource, spec, class, talent)
	return ressource[vexpower.powerBar.powerType] and spec[vexpower.data.specTabID] and class[vexpower.data.classString] and vexpower.markers.checkTalents(talent)
end

function vexpower.markers.create(pos)
	if pos < vexpower.powerBar.maxWidth and vexpower.powerBar.maxPower ~= 0 then
		local temp = CreateFrame("Frame", nil, vexpower.powerBar.frames.markers)
		temp:SetBackdrop({
			bgFile="Interface\\Buttons\\WHITE8X8", tile=false,
			edgeFile="Interface\\Buttons\\WHITE8X8",
			edgeSize=vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["border"]["size"]})
							
		if vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["colorLikeBG"] then
		
			local colors = vexpower.powerBar.getBarColors()
			temp:SetBackdropColor(colors[1],colors[2],colors[3],vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["color"]["a"])
		else
			temp:SetBackdropColor(
				vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["color"]["r"],
				vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["color"]["g"],
				vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["color"]["b"],
				vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["color"]["a"])
		end
		
		
		if vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["border"]["colorLikeBG"] then
			local colors = vexpower.powerBar.getBarColors()
			temp:SetBackdropBorderColor(colors[1],colors[2],colors[3],vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["design"]["BarColor"]["a"])
		else
			temp:SetBackdropBorderColor(vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["border"]["color"]["r"],
											vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["border"]["color"]["g"],
											vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["border"]["color"]["b"],
											vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["border"]["color"]["a"])
		end
		
		temp:SetFrameStrata(vexpower.options.strata.convertValues(vexpower_SV_profiles[vexpower_SV_data["profile"]]["data"]["strata"]["markers"]))
		temp:SetWidth(vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["markers"]["width"])
		temp:SetHeight(vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["design"]["size"]["height"]-(vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["design"]["border"]["size"]*2)-4)
		
		temp:SetPoint("TOPLEFT", vexpower.powerBar.frames.barBG, "TOPLEFT", pos, -vexpower_SV_profiles[vexpower_SV_data["profile"]]["powerbar"]["design"]["border"]["size"]-2)
		temp:Show()
		table.insert(vexpower.markers.created,#vexpower.markers.created+1, temp)
	end
end